searchData={"items":[{"type":"module","doc":"CommonCrawl library helps to interact with Common Crawl data.","title":"CommonCrawl","ref":"CommonCrawl.html"},{"type":"function","doc":"Cached collinfo from disk.","title":"CommonCrawl.collinfo/0","ref":"CommonCrawl.html#collinfo/0"},{"type":"function","doc":"CommonCrawl.collinfo()\n    [%{\n      \"cdx-api\" => \"https://index.commoncrawl.org/CC-MAIN-2021-43-index\",\n      \"id\" => \"CC-MAIN-2021-43\",\n      \"name\" => \"October 2021 Index\",\n      \"timegate\" => \"https://index.commoncrawl.org/CC-MAIN-2021-43/\"\n    }, ...]","title":"Examples - CommonCrawl.collinfo/0","ref":"CommonCrawl.html#collinfo/0-examples"},{"type":"function","doc":"Fetches current collinfo with all available crawls.\nMake sure to cache it and to not make repeated requests.","title":"CommonCrawl.get_collinfo/1","ref":"CommonCrawl.html#get_collinfo/1"},{"type":"function","doc":"iex> CommonCrawl.get_collinfo()\n    {:ok, [\n      %{\n        \"cdx-api\" => \"https://index.commoncrawl.org/CC-MAIN-2024-01-index\",\n        \"id\" => \"CC-MAIN-2024-01\",\n        \"name\" => \"January 2024 Index\",\n        \"timegate\" => \"https://index.commoncrawl.org/CC-MAIN-2024-01/\"\n      },\n      # ...more entries\n    ]}","title":"Examples - CommonCrawl.get_collinfo/1","ref":"CommonCrawl.html#get_collinfo/1-examples"},{"type":"function","doc":"Fetches the latest available crawl data for a given URL.","title":"CommonCrawl.get_latest_for_url/2","ref":"CommonCrawl.html#get_latest_for_url/2"},{"type":"function","doc":"iex> CommonCrawl.get_latest_for_url(\"https://example.com\")\n    {:ok,\n     %{\n       warc: \"WARC/1.0\\r\\nWARC-Type: response\\r\\nWARC-Date: 2024-01-14...\",\n       headers: \"HTTP/1.1 200 OK\\r\\nContent-Type: text/html...\",\n       response: \"<!doctype html>\\n \\n \\n Example Domain ...\"\n     }}","title":"Examples - CommonCrawl.get_latest_for_url/2","ref":"CommonCrawl.html#get_latest_for_url/2-examples"},{"type":"module","doc":"Interacting with index files of Common Crawl.","title":"CommonCrawl.Index","ref":"CommonCrawl.Index.html"},{"type":"function","doc":"Returns URL of the file containing the index paths for a given crawl ID.","title":"CommonCrawl.Index.all_paths_url/1","ref":"CommonCrawl.Index.html#all_paths_url/1"},{"type":"function","doc":"Returns URL of the cluster.idx file.","title":"CommonCrawl.Index.cluster_idx_url/1","ref":"CommonCrawl.Index.html#cluster_idx_url/1"},{"type":"function","doc":"iex> CommonCrawl.Index.cluster_idx_url(\"CC-MAIN-2017-34\")\n    \"https://data.commoncrawl.org/cc-index/collections/CC-MAIN-2017-34/indexes/cluster.idx\"","title":"Examples - CommonCrawl.Index.cluster_idx_url/1","ref":"CommonCrawl.Index.html#cluster_idx_url/1-examples"},{"type":"function","doc":"Filter filenames from cluster.idx with a given function.\nReturns a stream.","title":"CommonCrawl.Index.filter_cluster_idx/2","ref":"CommonCrawl.Index.html#filter_cluster_idx/2"},{"type":"function","doc":"# Get index files with \".de\" TLDs.\n    index_files =\n      CommonCrawl.Index.filter_cluster_idx(\n        cluster_idx,\n        fn line -> String.starts_with?(line, \"de\") end\n      )\n      |> Enum.to_list()","title":"Examples - CommonCrawl.Index.filter_cluster_idx/2","ref":"CommonCrawl.Index.html#filter_cluster_idx/2-examples"},{"type":"function","doc":"Fetches a gzipped index file.","title":"CommonCrawl.Index.get/3","ref":"CommonCrawl.Index.html#get/3"},{"type":"function","doc":"Fetches all available index files for a given crawl.\nAt the end of the list will be the \"metadata.yaml\" and the \"cluster.idx\" files.","title":"CommonCrawl.Index.get_all_paths/2","ref":"CommonCrawl.Index.html#get_all_paths/2"},{"type":"function","doc":"Fetches the cluster.idx file.","title":"CommonCrawl.Index.get_cluster_idx/2","ref":"CommonCrawl.Index.html#get_cluster_idx/2"},{"type":"function","doc":"Parses a line of an index file.","title":"CommonCrawl.Index.parser/1","ref":"CommonCrawl.Index.html#parser/1"},{"type":"function","doc":"Returns URL of the index file.","title":"CommonCrawl.Index.url/2","ref":"CommonCrawl.Index.html#url/2"},{"type":"function","doc":"iex> CommonCrawl.Index.url(\"CC-MAIN-2017-34\", \"cdx-00203.gz\")\n    \"https://data.commoncrawl.org/cc-index/collections/CC-MAIN-2017-34/indexes/cdx-00203.gz\"","title":"Examples - CommonCrawl.Index.url/2","ref":"CommonCrawl.Index.html#url/2-examples"},{"type":"module","doc":"Interacting with Common Crawl index search API.\n\nFurther info: [https://github.com/webrecorder/pywb/wiki/CDX-Server-API#api-reference](https://github.com/webrecorder/pywb/wiki/CDX-Server-API#api-reference)","title":"CommonCrawl.IndexAPI","ref":"CommonCrawl.IndexAPI.html"},{"type":"function","doc":"Searches the Common Crawl CDX API for entries matching the given query parameters.\n\nThe `cdx_api_url` can be found in `CommonCrawl.collinfo()`.\nThe `\"url\"` parameter is required in the `query` map.","title":"CommonCrawl.IndexAPI.get/3","ref":"CommonCrawl.IndexAPI.html#get/3"},{"type":"function","doc":"* `cdx_api_url` - The CDX API endpoint URL for a specific crawl\n  * `query` - Map of query parameters (url is required)\n  * `opts` - Request options passed to Req.get/2","title":"Parameters - CommonCrawl.IndexAPI.get/3","ref":"CommonCrawl.IndexAPI.html#get/3-parameters"},{"type":"function","doc":"# Search for a specific URL in a crawl\n    cdx_api_url = \"https://index.commoncrawl.org/CC-MAIN-2023-50-index\"\n    {:ok, entries} = CommonCrawl.IndexAPI.get(cdx_api_url, %{\"url\" => \"https://example.com\"})\n\n    # Search with additional filters\n    {:ok, entries} = CommonCrawl.IndexAPI.get(\n      cdx_api_url,\n      %{\n        \"url\" => \"https://example.com\",\n        \"filter\" => \"statuscode:200\",\n        \"limit\" => \"1\"\n      }\n    )","title":"Examples - CommonCrawl.IndexAPI.get/3","ref":"CommonCrawl.IndexAPI.html#get/3-examples"},{"type":"function","doc":"Searches for the latest available version of a URL across recent crawls.\nReturns the most recent entry if found, nil otherwise.","title":"CommonCrawl.IndexAPI.get_latest_for_url/2","ref":"CommonCrawl.IndexAPI.html#get_latest_for_url/2"},{"type":"function","doc":"# Search in default 4 most recent crawls\n    get_latest_for_url(\"https://example.com\")\n\n    # Search in 6 most recent crawls\n    get_latest_for_url(\"https://example.com\", crawls_to_check: 6)","title":"Examples - CommonCrawl.IndexAPI.get_latest_for_url/2","ref":"CommonCrawl.IndexAPI.html#get_latest_for_url/2-examples"},{"type":"function","doc":"{\"com,example)/\", 20241214183829,\n     %{\n       \"digest\" => \"JI6OR3QR4CI526JD6TMMNZNV4QPMPQCH\",\n       \"encoding\" => \"UTF-8\",\n       \"filename\" => \"crawl-data/CC-MAIN-2024-51/segments/1733066125982.36/warc/CC-MAIN-20241214181735-20241214211735-00433.warc.gz\",\n       \"languages\" => \"eng\",\n       \"length\" => \"1223\",\n       \"mime\" => \"text/html\",\n       \"mime-detected\" => \"text/html\",\n       \"offset\" => \"36544657\",\n       \"status\" => \"200\",\n       \"url\" => \"http://www.example.com\"\n     }}","title":"Return Value - CommonCrawl.IndexAPI.get_latest_for_url/2","ref":"CommonCrawl.IndexAPI.html#get_latest_for_url/2-return-value"},{"type":"module","doc":"Common Crawl .warc file download and parsing","title":"CommonCrawl.WARC","ref":"CommonCrawl.WARC.html"},{"type":"function","doc":"Fetches a segment of the WARC file.","title":"CommonCrawl.WARC.get_segment/4","ref":"CommonCrawl.WARC.html#get_segment/4"},{"type":"function","doc":"iex> CommonCrawl.WARC.get_segment(\n    ...>   \"crawl-data/CC-MAIN-2024-51/segments/1733066125982.36/warc/CC-MAIN-20241214181735-20241214211735-00433.warc.gz\",\n    ...>   36544657,\n    ...>   1223\n    ...> )","title":"Examples - CommonCrawl.WARC.get_segment/4","ref":"CommonCrawl.WARC.html#get_segment/4-examples"},{"type":"function","doc":"{:ok,\n     %{\n       warc: \"WARC/1.0\\r\\nWARC-Type: response\\r\\nWARC-Date: 2024...\",\n       headers: \"HTTP/1.1 200 OK\\r\\nContent-Type: text/html...\", \n       response: \"&lt;!doctype html&gt;\\n&lt;html&gt;\\n&lt;head&gt;\\n&lt;title&gt;Example...\"\n     }}","title":"Return Value - CommonCrawl.WARC.get_segment/4","ref":"CommonCrawl.WARC.html#get_segment/4-return-value"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}